/*----------------------------------------------------------------------------
/ USBN9604											2005 (C)LogicPack
/	05.07.22					000		M.Yamada
/		first release(use M-802)
/---------------------------------------------------------------------------*/
#ifndef __USBN9604_H_
#define __USBN9604_H_

#include "lp.h"

/*-----------------------------------------------
/ *DEFINE
/----------------------------------------------*/
#if defined(DEBUG_LOG_INTR)
	#define USB_LOG_MAX 10000
#endif

typedef struct{
	byte event;
	byte sub;
	byte rxstat;
	byte ub0;
	byte ub1;
	byte ub2;
	byte ub3;
	byte ub4;
	byte ub5;
}USB_LOG;

/* fXNNv^ݒ */
typedef struct{
	byte *device;
	byte *config;
	byte *langage;
	byte *mfg_str;
	byte *nbr_str;
	byte *int_str;
}DESCRIPTOR_INFO;

typedef struct{
	bool class_request;			/* NXNGXg̉T|[g */
	byte *report_desc;			/* |[gfXNv^ */
	bool set_interface;			/* SET INTERFACẼT|[g */
	bool dummy;
}SETTING_INFO;

/* ƃobt@ݒ */
typedef struct{
	int no;				/* TX/RXԍ */
	byte *tmp;			/* ƃobt@ւ̃|C^ */
	int size;			/* ƃobt@TCY */
	bool addition;		/* f[^ǉtO */
}USBBUF_INFO;

/* Gh|Cgݒ */
typedef struct{
	byte epc;			/* 蓖EPCԍ */
	byte addr;			/* 蓖ăAhXԍ */
	bool iso;			/* AC\NiX]tO */
}ENDPOINT_INFO;

#if defined(DEBUG_LOG_INTR)
extern USB_LOG usb_log_buf[USB_LOG_MAX];
extern int usb_log_count;
extern int usb_intr_count;
#endif

/*-----------------------------------------------
/ *PROTOTYPE
/----------------------------------------------*/
void UsbInit(void);
void UsbReset(void);

void UsbSetAction(const DESCRIPTOR_INFO *desc, const SETTING_INFO *set);

void UsbSetWriteBuf(const USBBUF_INFO *buf, const ENDPOINT_INFO *endp);
int UsbPut(int no, const byte *p,int size);

void UsbSetReadBuf(const USBBUF_INFO *buf, const ENDPOINT_INFO *endp);
int UsbGet(int no, byte *p,int size);
int UsbGetBufLen(int no);

#endif
